"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ArrayUtils_1 = require("../utils/ArrayUtils");
const GraphNode_1 = require("./GraphNode");
var ClusterType;
(function (ClusterType) {
    ClusterType[ClusterType["Root"] = 0] = "Root";
    ClusterType[ClusterType["TopLevel"] = 1] = "TopLevel";
    ClusterType[ClusterType["AreaWithSubFolders"] = 2] = "AreaWithSubFolders";
    ClusterType[ClusterType["FromOptimization"] = 3] = "FromOptimization";
    // from the tslint.json file 'diagramCluster':
    ClusterType[ClusterType["DiagramCluster"] = 4] = "DiagramCluster";
})(ClusterType = exports.ClusterType || (exports.ClusterType = {}));
class GraphCluster extends GraphNode_1.GraphNode {
    constructor() {
        super(...arguments);
        this.nodes = [];
        this.clusterType = ClusterType.TopLevel;
    }
    static create(parent, numericId, name, description, clusterType) {
        const cluster = new GraphCluster(parent, "C" + numericId, name, description);
        cluster.clusterType = clusterType;
        return cluster;
    }
    removeNode(node) {
        ArrayUtils_1.ArrayUtils.removeFrom(this.nodes, node);
    }
}
exports.GraphCluster = GraphCluster;
//# sourceMappingURL=GraphCluster.js.map