"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ArrayUtils_1 = require("../utils/ArrayUtils");
var NodeType;
(function (NodeType) {
    NodeType[NodeType["Normal"] = 0] = "Normal";
    NodeType[NodeType["External"] = 1] = "External";
    // The 'any' (*) package or folder:
    NodeType[NodeType["Any"] = 2] = "Any";
})(NodeType = exports.NodeType || (exports.NodeType = {}));
class GraphNode {
    constructor(parent, id, name, description = "", nodeType = NodeType.Normal) {
        this.parent = parent;
        this.id = id;
        this.name = name;
        this.description = description;
        this.nodeType = nodeType;
        this.incomingEdges = [];
        this.outgoingEdges = [];
    }
    removeIncomingEdge(edge) {
        ArrayUtils_1.ArrayUtils.removeFrom(this.incomingEdges, edge);
    }
    removeOutgoingEdge(edge) {
        ArrayUtils_1.ArrayUtils.removeFrom(this.outgoingEdges, edge);
    }
}
exports.GraphNode = GraphNode;
//# sourceMappingURL=GraphNode.js.map