"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const GraphCluster_1 = require("../GraphCluster");
const VisitedIdTracker_1 = require("./VisitedIdTracker");
class GraphVisitor {
    constructor(root) {
        this.root = root;
        this.visited = new VisitedIdTracker_1.VisitedIdTracker();
    }
    visitEdges(visit) {
        const allEdges = [];
        const visitedEdges = new VisitedIdTracker_1.VisitedIdTracker();
        const addNodeEdges = (node) => {
            node.incomingEdges.forEach(edge => {
                if (!visitedEdges.isVisitedOrAdd(edge.id)) {
                    allEdges.push(edge);
                }
            });
            node.outgoingEdges.forEach(edge => {
                if (!visitedEdges.isVisitedOrAdd(edge.id)) {
                    allEdges.push(edge);
                }
            });
        };
        this.visitNodesAndClusters(addNodeEdges);
        allEdges.map(visit);
    }
    visitNodesAndClusters(visit) {
        const visitNode = (node) => {
            if (this.visited.isVisitedOrAdd(node.id)) {
                return;
            }
            visit(node);
            if (node instanceof GraphCluster_1.GraphCluster) {
                node.nodes.map(visitNode);
            }
        };
        visitNode(this.root);
    }
}
exports.GraphVisitor = GraphVisitor;
//# sourceMappingURL=GraphVisitor.js.map