"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class MapIdToGraphNode {
    constructor() {
        this.mapIdToNode = new Map();
    }
    add(node) {
        const id = node.id;
        if (this.mapIdToNode.has(id)) {
            throw new Error(`already have an entry for id ${id}`);
        }
        this.mapIdToNode.set(id, node);
    }
    getByIdOrThrow(id) {
        if (!this.mapIdToNode.has(id)) {
            throw new Error(`id ${id} not found in graph map!`);
        }
        return this.mapIdToNode.get(id);
    }
}
exports.MapIdToGraphNode = MapIdToGraphNode;
//# sourceMappingURL=MapIdToGraphNode.js.map