"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Track visited IDs to avoid circular references causing an infinite loop!
 */
class VisitedIdTracker {
    constructor() {
        this.visitedIds = new Map();
    }
    isVisitedOrAdd(id) {
        if (this.visitedIds.has(id)) {
            return true;
        }
        this.visitedIds.set(id, true);
        return false;
    }
}
exports.VisitedIdTracker = VisitedIdTracker;
//# sourceMappingURL=VisitedIdTracker.js.map