"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const ConfigFactory_1 = require("../../../config/ConfigFactory");
var TslintConfigLoader;
(function (TslintConfigLoader) {
    function loadTslintConfig(config) {
        return new Promise((resolve, reject) => {
            fs.readFile(config.pathToTslintJson, "utf8", function (err, data) {
                if (err) {
                    reject(err);
                }
                else {
                    const json = JSON.parse(data);
                    const packageConfigJson = json.rules["tsf-folders-imports-between-packages"][1];
                    const packageConfig = ConfigFactory_1.ConfigFactory.createForBetweenPackages([
                        packageConfigJson
                    ]);
                    resolve(packageConfig);
                }
            });
        });
    }
    TslintConfigLoader.loadTslintConfig = loadTslintConfig;
})(TslintConfigLoader = exports.TslintConfigLoader || (exports.TslintConfigLoader = {}));
//# sourceMappingURL=TslintConfigLoader.js.map